/**
far away - a free space shooter game
Copyright (C) 2005  Alexander Clausen, Dirk Rathlev, Stefan Toller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "SDL.h"
#include <string.h>

#include "faraway.h"

extern faMain* g_pfaMain;

int Campaign::campaign_init()
{
	actual_map = 0;
	num_maps = 0;
	return 0;
}

int Campaign::exit_campaign()
{
	unsigned int i;
	for (i=0; i<num_maps; i++)
	{
		if (level_paths[i])
		{
			free(level_paths[i]);
		}
	}
	
	return 0;
}

int Campaign::load_campaign(const char *filename)
{
	FILE* file;
	char path[30];
	unsigned int i;
	
	actual_map = 0;
	num_maps = 0;
	
	file = fopen(filename,"r");
	if (file == NULL)
	{
		return 1;
	}
	
	fscanf(file,"%d\n",&num_maps);
	printf("num_maps: %d\n",num_maps);
	
	for (i=0; i<num_maps; i++)
	{
		fscanf(file,"%s\n",path);
		level_paths[i] = (char*)malloc(sizeof(char)*30);
		strcpy(level_paths[i],path);
		printf("%s\n",level_paths[i]);
	}
	
	fclose(file);
	
	g_pfaMain->g_pObjects->clear_level();
	
	if (g_pfaMain->g_pObjects->load_level(level_paths[actual_map]))
	{
		printf("level load failed\n");
		return 1;
	}

	return 0;
}

int Campaign::next_level()
{
	actual_map++;
	printf("map %d/%d\n",actual_map,num_maps);
	if (actual_map >= num_maps)
	{
		printf("campaign solved %d/%d\n",actual_map,num_maps);
		// show game over screen
		g_pfaMain->GameState = GS_SPLASH;
		g_pfaMain->continue_at = GS_QUIT;
		g_pfaMain->splash = 2;
		return 1;
	}
	
	// delete all objects
	g_pfaMain->g_pObjects->clear_level();

	if (g_pfaMain->g_pObjects->load_level(level_paths[actual_map]))
	{
		printf("level load %s (%d) failed\n",level_paths[actual_map],actual_map);
		return 1;
	}
	printf("next level succesful loaded\n");
	
	g_pfaMain->way_passed = 0.0f;
	g_pfaMain->GameState = GS_GAME;
		
	return 0;
}

