/**
far away - a free space shooter game
Copyright (C) 2005  Alexander Clausen, Dirk Rathlev, Stefan Toller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// Includes
#include <iostream>
#include <list>

#include "globals.h"
#include "input.h"
#include "objects.h"
#include "sound.h"
#include "ui.h"
#include "campaign.h"

using namespace std;

class faMain
{
	private:
		Uint32 Time1, Time2;
		float faverage_fTime[5];
	
	public:
	// variables
	// correction factor movements etc.
		float fTime;
		
	// which target? (ZARGET_* in globals.h)
		unsigned int nTargetType;
	// length of the level in pixels or seconds
		int level_length;
	// already finished way/passed time
		float way_passed;

	// actual absolut scroll values
		int nScroll_x,nScroll_y;

	// game state
		int			GameState;
		
	// speed with which the level scrolls
		float	game_speed;
	// when going to show a splash screen, set continue_at to the wished GS after showing the splash
		int	continue_at;
	// splash to show at the moment
		int	splash;
		
	// configs such as fullscreen, audio sample rate etc.
		SConfig	Configs;
	
		
	// classes

	// input class
		Input*				g_pInput;	
		Objects*			g_pObjects;
		Sound*				g_pSound;
		UI*				g_pUI;
		Campaign*			g_pCampaign;

	// functions

	// initialize the game	
		int game_init();
	// tidy up
		void game_exit();
	// render the frame
		void render(SDL_Surface * screen);
	// function with the game loop
		int game_loop();
	// takes a string as parameter and checks whether it's "yes" or "no"
		bool get_bool_from_string(char* s);
	// takes a string as parameter and gives back an integer
		int get_int_from_string(char* s);
	// loads specs from config file
		int load_configs(const char* filename);
		
		

};
