/**
far away - a free space shooter game
Copyright (C) 2005  Alexander Clausen, Dirk Rathlev, Stefan Toller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "SDL.h"	
#include <stdio.h>
#include <stdlib.h>
#include "faraway.h"


extern faMain* g_pfaMain;

int Input::input_init()
{
	keys=SDL_GetKeyState(NULL);
	
	Mouse.x = 0;
	Mouse.y = 0;
	Mouse.buttonl = false;
	Mouse.buttonr = false;
	
	ok = true;
	return 0;
}

int Input::process_input(void)
{
	/*if (g_pfaMain->GameState == GS_GAME)
	{
		// set speed_x/speed_y to 0 (do this only for player)
		g_pfaMain->g_plObjects->lObjects[num_player1].speed_x = 0;
		lObjects[num_player1].speed_y = 0;
		if (g_pfaMain->g_pInput->keys[SDLK_UP] == SDL_PRESSED)
		{
			lObjects[num_player1].speed_y = -lObjects[num_player1].ObjType->speed;
		}
		if (g_pfaMain->g_pInput->keys[SDLK_DOWN] == SDL_PRESSED)
		{
			lObjects[num_player1].speed_y = lObjects[num_player1].ObjType->speed;
		}
		if (g_pfaMain->g_pInput->keys[SDLK_LEFT] == SDL_PRESSED)
		{
			lObjects[num_player1].speed_x = -lObjects[num_player1].ObjType->speed;
		}
		if (g_pfaMain->g_pInput->keys[SDLK_RIGHT] == SDL_PRESSED)
		{
			lObjects[num_player1].speed_x = lObjects[num_player1].ObjType->speed;
		}
	
		if (lObjects[num_player1].x < 0)
		{
			lObjects[num_player1].x = 0;
		}
		if (lObjects[num_player1].x+lObjects[num_player1].ObjType->w > SCREEN_W)
		{
			lObjects[num_player1].x = SCREEN_W-lObjects[num_player1].ObjType->w;
		}
		if (lObjects[num_player1].y < 0)
		{
			lObjects[num_player1].y = 0;
		}
		if (lObjects[num_player1].y+lObjects[num_player1].ObjType->h > SCREEN_H)
		{
			lObjects[num_player1].y = SCREEN_H-lObjects[num_player1].ObjType->h;
		}
	
		if ( (g_pfaMain->g_pInput->keys[SDLK_SPACE] == SDL_PRESSED) &&
				    (lObjects[num_player1].fwcounter > lObjects[num_player1].ObjType->ffiring) )
		{
			fire_weapon(&lObjects[num_player1]);
		}
	}*/
	
	if ( (keys[SDLK_ESCAPE] == SDL_PRESSED) && (ok) )
	{
		ok = false;
		switch(g_pfaMain->GameState) {
			case GS_START_MENU:
				g_pfaMain->GameState = GS_QUIT;
				break;
			case GS_GAME:
				g_pfaMain->GameState = GS_MENU;
				break;
			case GS_MENU:
				g_pfaMain->GameState = GS_GAME;
				break;
			case GS_GAMEOVER:
				g_pfaMain->GameState = GS_MENU;
				break;
			default:
				printf("gamestate %d not handled\n", g_pfaMain->GameState);
				break;
		}
	}

	if ( (keys[SDLK_RETURN] == SDL_PRESSED) && (ok) )
	{
		switch(g_pfaMain->GameState) {
			case GS_SPLASH:
				ok = false;
				g_pfaMain->GameState = g_pfaMain->continue_at;
				break;
			default:
				printf("gamestate %d not handled\n", g_pfaMain->GameState);
				break;
		}
	}

	return 0;
}

int Input::eventloop(void)
{
	SDL_Event event;
	while (SDL_PollEvent (&event) != 0)
	{
		switch (event.type)
		{
			case SDL_KEYDOWN:
				keys=SDL_GetKeyState(NULL);
				break;
			case SDL_KEYUP:
			{
				ok = true;
			}
				
				break;
			case SDL_MOUSEBUTTONDOWN:
			{
				if (event.button.button == 1)
				{
					Mouse.buttonl = true;
				}
				else if (event.button.button == 3)
				{
					Mouse.buttonr = true;
				}
				printf ("Maus-Button (%d) gedrueckt an Position "
						" (x:%d,y:%d)]\n",
				event.button.button, event.button.x, event.button.y);
			}
			break;
			case SDL_MOUSEBUTTONUP:
			{
				if (event.button.button == 1)
				{
					Mouse.buttonl = false;
				}
				else if (event.button.button == 3)
				{
					Mouse.buttonr = false;
				}
				printf ("Maus-Button (%d) losgelassen an Position "
						" (x:%d,y:%d)]\n",
				event.button.button, event.button.x, event.button.y);
			}
			break;
			case SDL_MOUSEMOTION:
				Mouse.x = event.button.x;
				Mouse.y = event.button.y;
				break;
			case SDL_QUIT:
				g_pfaMain->game_exit();
				printf ("Quit event. Bye.\n");
				exit (EXIT_SUCCESS);
		}
	}
	return 1;
}
