unit HPrg; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls, Spin, ComCtrls, Menus, lvloptions;

const
  MAX_OBJECTS        = 100;
  MAX_OBJ_TYPES      = 50;
  NUM_IMAGES         = 10;
  MAX_WEAPONS        = 5;
  
  SCREEN_H           = 600;
  
  LEVEL_W            = 4000;
  VERSION            = '0.0.1';
  
type
  TWeapon = record
    nWType: integer;
    x,y: integer;
    end;

type
  TObj = record
    bMarked: boolean;
    x,y: integer;
    w,h: integer;
    nImage: integer;
    nType: integer;
    nObjType: integer;
    hp: integer;
    numWeapons: integer;
    Weapons: array[0..MAX_WEAPONS] of TWeapon;
    name: string[20];
    end;
    
type
  TMyMouse = record
    x,y: integer;
    end;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button3: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3m: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    OpenDialog1: TOpenDialog;
    PaintBox1: TPaintBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioGroup1: TRadioGroup;
    SaveDialog1: TSaveDialog;
    SpinEdit4: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit1: TSpinEdit;
    Timer1: TTimer;
    TrackBar2: TTrackBar;
    TrackBar1: TTrackBar;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Form1Create(Sender: TObject);
    procedure Form1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Form1KeyPress(Sender: TObject; var Key: char);
    procedure Form1Resize(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure RadioButton1Change(Sender: TObject);
    procedure RadioButton2Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    { private declarations }
    Backbuffer:            TBitmap;
    standardpath:          string;
    Objects:               array[0..MAX_OBJECTS] of TObj;
    ObjTypes:              array[0..MAX_OBJ_TYPES] of TObj;
    Images:                array[0..NUM_IMAGES] of TBitmap;
    Mouse:                 TMyMouse;
    nObjects:              integer;
    newObj:                TObj;
    scroll_x,scroll_y:     integer;
    nObjectTypes:          integer;
    // index of marked object
    nMarked:               integer;
    
    procedure Init;
    procedure ClearSurface;
    procedure DrawWireframe(Obj: TObj);
    procedure DrawSurface;
    procedure BlitSurface;
    procedure ImportLevel(filename: string);
    procedure ExportLevel(filename: string);
    function count_objects: integer;
    procedure create_object(Obj: TObj);
    procedure LoadObjectTypes(filename: string);
    procedure update_controls(nObj: integer);
    function get_separator(c: char; s: string): integer;
    function getnextint(var s: string; c: char): integer;
    procedure ClearLevel;
  public
    { public declarations }
    nTargetType:           integer;
    nLevelLength:          integer;
  end; 

var
  Form1: TForm1; 

implementation

procedure TForm1.Form1Create(Sender: TObject);
begin
  Init;
  end;

procedure TForm1.Form1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin

  end;

procedure TForm1.Form1KeyPress(Sender: TObject; var Key: char);
begin
end;

procedure TForm1.Form1Resize(Sender: TObject);
begin
  PaintBox1.Height := Form1.Height-(PaintBox1.Top+30);
  Backbuffer.Height := PaintBox1.Height;
  end;

procedure TForm1.Label1Click(Sender: TObject);
begin

end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  ClearLevel;
  end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    ImportLevel(OpenDialog1.FileName);
    end;
  end;

procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
    ExportLevel(SaveDialog1.Filename);
    end;
  end;

procedure TForm1.MenuItem6Click(Sender: TObject);
begin
  Close;
  end;

procedure TForm1.MenuItem8Click(Sender: TObject);
begin
  Form2.Show;
  end;

procedure TForm1.PaintBox1Click(Sender: TObject);
begin

end;

procedure TForm1.PaintBox1MouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i: integer;
begin
  if Button = mbLeft then begin
    nMarked := -1;
    Button5.Hide;
    SpinEdit3.Hide;
    SpinEdit4.Hide;
    update_controls(-1);
    if newObj.nType = 0 then begin
      for i:=0 to MAX_OBJECTS do if Objects[i].nType <> 0 then begin
        Objects[i].bMarked := false;
        if (X > Objects[i].x-scroll_x) and (x < Objects[i].x-scroll_x+Objects[i].w) and
           (Y > Objects[i].y-scroll_y) and (y < Objects[i].y-scroll_y+Objects[i].h) then begin
          Objects[i].bMarked := true;
          nMarked := i;
          SpinEdit2.Value := Objects[i].nType;
          Edit2.Text := IntToStr(Objects[i].hp);
          SpinEdit1.Value := Objects[i].numWeapons;
          Button5.Show;
          update_controls(i);
          end;
        end;
      end
    else begin
      newObj.x := X+scroll_x;
      newObj.y := Y+scroll_y;
      create_object(newObj);
      end;
    end
  else if Button = mbMiddle then begin
    newObj.nType := 0;
    RadioButton1.Checked := true;
    end;
  end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  i: integer;
begin
  if ssLeft in Shift then begin
    for i:=0 to MAX_OBJECTS do begin
      if Objects[i].bMarked then begin
        Objects[i].x := Objects[i].x-(Mouse.x-X);
        Objects[i].y := Objects[i].y-(Mouse.y-Y);
        end;
      end;
    end
  else if ssRight in Shift then begin
    scroll_x := scroll_x+(Mouse.x-X);
    scroll_y := scroll_y+(Mouse.y-Y);
    if scroll_x<0 then scroll_x := 0;
    if scroll_y<0 then scroll_y := 0;
    if scroll_y>SCREEN_H then scroll_y := SCREEN_H;
    if scroll_x>LEVEL_W then scroll_x := LEVEL_W;
    end;
  Mouse.x := X;
  Mouse.y := Y;
  Label9.Caption := 'mouse: '+IntToStr(X+scroll_x)+'/'+IntToStr(Y+scroll_y);
  end;

procedure TForm1.RadioButton1Change(Sender: TObject);
begin
  if RadioButton1.Checked then begin
    newObj.nType := 0;
    end;
  end;

procedure TForm1.RadioButton2Change(Sender: TObject);
var
  i: integer;
begin
  if RadioButton2.Checked then begin
    for i:=0 to MAX_OBJECTS do begin
      Objects[i].bMarked := false;
      end;
    nMarked := -1;

    with newObj do begin
      nType := trunc(SpinEdit2.Value);
      w := ObjTypes[nType].w;
      h := ObjTypes[nType].h;
      hp := ObjTypes[nType].hp;
      numWeapons := 1;
      Weapons[1].nWType := 0;
      Weapons[1].x := -20;
      Weapons[1].y := ObjTypes[nType].h div 2;
      nImage := ObjTypes[nType].nImage;
      end;
    update_controls(-1);
    end;
  end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  if nMarked >= 0 then with Objects[nMarked] do begin
    numWeapons := trunc(SpinEdit1.Value);
    if numWeapons > 0 then begin
      SpinEdit3.Value := 1;
      end;
    update_controls(nMarked);
    end;
  end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  if nMarked >= 0 then with Objects[nMarked] do begin
    nType := trunc(SpinEdit2.Value);
    w := ObjTypes[nType].w;
    h := ObjTypes[nType].h;
    nImage := ObjTypes[nType].nImage;
    end
  else if newObj.nType <> 0 then with newObj do begin
    nType := trunc(SpinEdit2.Value);
    w := ObjTypes[nType].w;
    h := ObjTypes[nType].h;
    hp := ObjTypes[nType].hp;
    end;
  update_controls(nMarked);
  end;

procedure TForm1.SpinEdit3Change(Sender: TObject);
begin
  update_controls(nMarked);
  end;

procedure TForm1.SpinEdit4Change(Sender: TObject);
begin
  if nMarked >= 0 then with Objects[nMarked].Weapons[trunc(SpinEdit3.Value)] do begin
    nWType := trunc(SpinEdit4.Value);
    end;
  end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    ClearLevel;
    ImportLevel(OpenDialog1.FileName);
    Form1.Caption := 'Far Away Level Editor '+VERSION+' ['+OpenDialog1.Filename+']';
    end;
  end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  newObj.nType := 0;
  end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
    ExportLevel(SaveDialog1.Filename);
    Form1.Caption := 'Far Away Level Editor '+VERSION+' ['+SaveDialog1.Filename+']';
    end;
  end;

procedure TForm1.Button4Click(Sender: TObject);
var
  i: integer;
begin
  for i:=0 to MAX_OBJECTS do begin
    Objects[i].bMarked := false;
    end;
  nMarked := -1;

  with newObj do begin
    nType := trunc(SpinEdit2.Value);
    w := ObjTypes[nType].w;
    h := ObjTypes[nType].h;
    hp := ObjTypes[nType].hp;
    numWeapons := 1;
    Weapons[1].nWType := 0;
    Weapons[1].x := -20;
    Weapons[1].y := ObjTypes[nType].h div 2;
    nImage := ObjTypes[nType].nImage;
    end;
  end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Objects[nMarked].nType := 0;
  end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if nMarked >= 0 then begin
    newObj := Objects[nMarked];
    end;
  end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  if nMarked >= 0 then with Objects[nMarked] do begin
    hp := StrToInt(Edit2.Text);
    end;
  end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ClearSurface;
  DrawSurface;
  BlitSurface;
  end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  if nMarked >= 0 then with Objects[nMarked].Weapons[trunc(SpinEdit3.Value)] do begin
    x := TrackBar1.Position;
    Label3.Caption := 'x: '+IntToStr(x);
    end;
  end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  if nMarked >= 0 then with Objects[nMarked].Weapons[trunc(SpinEdit3.Value)] do begin
    y := TrackBar2.Position;
    Label4.Caption := 'y: '+IntToStr(y);
    end;
  end;

procedure TForm1.Init;
var
  i: integer;
begin
  standardpath := ExtractFilePath(Application.ExeName);
  OpenDialog1.Filename := standardpath + 'maps/*.fa';
  SaveDialog1.Filename := standardpath + 'maps/*.fa';
  PaintBox1.Width := 600;
  PaintBox1.Height := Form1.Height-(PaintBox1.Top+30);
  Backbuffer := TBitmap.Create;
  Backbuffer.Width := PaintBox1.Width;
  Backbuffer.Height := PaintBox1.Height;
(*
 for i:=0 to NUM_IMAGES do begin
    Images[i] := TBitmap.Create;
    end;
    
  Images[0].LoadFromFile('graphics/asteroid.bmp');
  Images[1].LoadFromFile('graphics/asteroid.bmp');
  Images[2].LoadFromFile('graphics/ship4.bmp');
  Images[3].LoadFromFile('graphics/asteroid.bmp');
  Images[4].LoadFromFile('graphics/med.bmp');
  Images[5].LoadFromFile('graphics/enemy2.bmp');
  Images[6].LoadFromFile('graphics/ship5.bmp');
  Images[7].LoadFromFile('graphics/enemy3.bmp');*)
  
  LoadObjectTypes(standardpath+'data/objtypes');
  
  ClearLevel;
  end;

procedure TForm1.ClearSurface;
begin
  with Backbuffer.Canvas do begin
    Pen.Color := clBlack;
    Brush.Color := clBlack;
    FillRect(Rect(0,0,Backbuffer.Width,Backbuffer.Height));
    end;
  end;
  
procedure TForm1.DrawWireframe(Obj: TObj);
var
  i: integer;
begin
  with Backbuffer.Canvas do begin
    if Obj.bMarked then
     Pen.Color := clYellow
    else
     Pen.Color := clRed;
    with Obj do begin
      MoveTo(x-scroll_x,y-scroll_y);
      LineTo(x-scroll_x+w,y-scroll_y);
      LineTo(x-scroll_x+w,y-scroll_y+h);
      LineTo(x-scroll_x,y-scroll_y+h);
      LineTo(x-scroll_x,y-scroll_y);
      LineTo(x-scroll_x+w,y-scroll_y+h);
      for i:=1 to numWeapons do begin
        if (Obj.bMarked) and (trunc(SpinEdit3.Value)=i) then
         Pen.Color := clRed
        else
         Pen.Color := clLime;
        MoveTo(x+Weapons[i].x-scroll_x-10,y+Weapons[i].y-scroll_y-10);
        LineTo(x+Weapons[i].x-scroll_x+10,y+Weapons[i].y-scroll_y+10);
        MoveTo(x+Weapons[i].x-scroll_x+10,y+Weapons[i].y-scroll_y-10);
        LineTo(x+Weapons[i].x-scroll_x-10,y+Weapons[i].y-scroll_y+10);
        end;
      end;
    end;
  end;
  
procedure TForm1.DrawSurface;
var
  i: integer;
begin
  with Backbuffer.Canvas do begin
    Pen.Color := clLime;
    MoveTo(0,SCREEN_H-scroll_y);
    LineTo(nLevelLength-scroll_x,SCREEN_H-scroll_y);
    if nTargetType = 2 then
     LineTo(nLevelLength-scroll_x,0);
    for i:=0 to MAX_OBJECTS do if Objects[i].nType <> 0 then begin
      DrawWireframe(Objects[i]);
      //Draw(Objects[i].x,Objects[i].y,Images[Objects[i].nImage]);
      end;
    if newObj.nType <> 0 then begin
      newObj.x := Mouse.x+scroll_x;
      newObj.y := Mouse.y+scroll_y;
      DrawWireframe(newObj);
      end;
    end;
  end;

procedure TForm1.BlitSurface;
begin
  PaintBox1.Canvas.Draw(0,0,Backbuffer);
  end;
  
procedure TForm1.ImportLevel(filename: string);
var
  f: TextFile;
  s: string;
  i,j,num_objects: integer;

procedure parse_line(s: string; i: integer);
var
  sep: integer;
  s1,s2: string;
begin
   with Objects[i] do begin
    nType := getnextint(s,',');
    x := getnextint(s,',');
    y := getnextint(s,',');
    hp := getnextint(s,',');
    numWeapons := getnextint(s,',');
    end;
  end;
  
procedure parse_weapon_line(s: string; i,j: integer);
var
  sep: integer;
  s1,s2: string;
begin
  with Objects[i].Weapons[j] do begin
    nWType := getnextint(s,',');
    x := getnextint(s,',');
    y := getnextint(s,',');
    end;
  end;
  

begin
  AssignFile(f,filename);
  reset(f);
  readln(f,s);
  num_objects := getnextint(s,',');
  nTargetType := getnextint(s,',');
  nLevelLength := getnextint(s,',');
  for i:=0 to num_objects-1 do begin
    readln(f,s);
    parse_line(s,i);
    for j:=1 to Objects[i].numWeapons do begin
      readln(f,s);
      parse_weapon_line(s,i,j);
      end;
    Objects[i].nImage := ObjTypes[Objects[i].nType].nImage;
    Objects[i].w := ObjTypes[Objects[i].nType].w;
    Objects[i].h := ObjTypes[Objects[i].nType].h;
    end;
  CloseFile(f);
  end;
  
procedure TForm1.ExportLevel(filename: string);
var
  i,j: integer;
  f: TextFile;
begin
  AssignFile(f,filename);
  rewrite(f);

  writeln(f,IntToStr(count_objects)+','+IntToStr(nTargetType)+','+
            IntToStr(nLevelLength));

  for i:=0 to MAX_OBJECTS do if Objects[i].nType <> 0 then with Objects[i] do begin
    writeln(f,IntToStr(nType)+','+IntToStr(x)+','+IntToStr(y)+','+
            IntToStr(hp)+','+IntToStr(numWeapons));
    for j:=1 to numWeapons do with Weapons[j] do begin
      writeln(f,' ',IntToStr(nWType)+','+IntToStr(x)+','+IntToStr(y));
      end;
    end;
    
  CloseFile(f);
  end;
  
function TForm1.count_objects: integer;
var
  i: integer;
begin
  count_objects := 0;
  for i:=0 to MAX_OBJECTS do begin
    if Objects[i].nType <> 0 then begin
      inc(count_objects);
      end;
    end;
  end;
  
procedure TForm1.create_object(Obj: TObj);
var
  i: integer;
begin
  for i:=0 to MAX_OBJECTS do if Objects[i].nType=0 then with Objects[i] do begin
    Objects[i] := Obj;
    break;
    end;
  end;
  
procedure TForm1.LoadObjectTypes(filename: string);
procedure parse_line(s: string; i: integer);
var
  sep: integer;
  s1,s2: string;
begin
  s1 := s;

  sep := get_separator(chr(9),s1)+1;
  s2 := Copy(s1,0,sep-2);
  ObjTypes[i].nObjType := StrToInt(s2);
  s1 := Copy(s1,sep,Length(s1)-sep+1);

  sep := get_separator(chr(9),s1)+1;
  s2 := Copy(s1,0,sep-2);
  ObjTypes[i].w := StrToInt(s2);
  s1 := Copy(s1,sep,Length(s1)-sep+1);

  sep := get_separator(chr(9),s1)+1;
  s2 := Copy(s1,0,sep-2);
  ObjTypes[i].h := StrToInt(s2);
  s1 := Copy(s1,sep,Length(s1)-sep+1);

  // ignore speed
  sep := get_separator(chr(9),s1)+1;
  s1 := Copy(s1,sep,Length(s1)-sep+1);
  
  // get nImage
  sep := get_separator(chr(9),s1)+1;
  s2 := Copy(s1,0,sep-2);
  ObjTypes[i].nImage := StrToInt(s2);
  s1 := Copy(s1,sep,Length(s1)-sep+1);
  
  // ignore maxanim and animspeed
  sep := get_separator(chr(9),s1)+1;
  s1 := Copy(s1,sep,Length(s1)-sep+1);
  
  sep := get_separator(chr(9),s1)+1;
  s1 := Copy(s1,sep,Length(s1)-sep+1);
  
  // ignore flifetime
  sep := get_separator(chr(9),s1)+1;
  s1 := Copy(s1,sep,Length(s1)-sep+1);
  
  // get maxhp
  sep := get_separator(chr(9),s1)+1;
  s2 := Copy(s1,0,sep-2);
  ObjTypes[i].hp := StrToInt(s2);
  s1 := Copy(s1,sep,Length(s1)-sep+1);
  
  // get name
  s2 := s1;
  ObjTypes[i].name := s2;

  end;
var
  f: TextFile;
  s: string;
  i: integer;
begin
  AssignFile(f,filename);
  reset(f);
  readln(f,s);
  nObjectTypes := StrToInt(s);
  for i:=1 to nObjectTypes do begin
    readln(f,s);
    parse_line(s,i);
    end;
  CloseFile(f);
  SpinEdit2.MaxValue := nObjectTypes;
  end;
  
procedure TForm1.update_controls(nObj: integer);
begin
  Button6.Hide;
  SpinEdit3.Hide;
  SpinEdit4.Hide;
  TrackBar1.Hide;
  TrackBar2.Hide;
  Label1.Hide;
  Label3.Hide;
  Label4.Hide;
  Label5.Hide;
  Label6.Caption := 'name: '+ObjTypes[trunc(SpinEdit2.Value)].name;
  Label8.Hide;
  TrackBar1.Hide;
  TrackBar2.Hide;
  if nMarked >= 0  then with Objects[nObj] do begin
    if numWeapons > 0 then begin
      Button6.Show;
      SpinEdit3.MaxValue := numWeapons;
      SpinEdit3.Show;
      SpinEdit4.Show;
      TrackBar1.Show;
      TrackBar2.Show;
      Label1.Show;
      Label3.Show;
      Label4.Show;
      Label5.Show;
      Label6.Show;
      Label8.Show;
      Label3.Caption := 'x: '+IntToStr(Weapons[trunc(SpinEdit3.Value)].x);
      Label4.Caption := 'y: '+IntToStr(Weapons[trunc(SpinEdit3.Value)].y);
      Label6.Caption := 'name: '+ObjTypes[nType].name;
      SpinEdit4.Value := Weapons[trunc(SpinEdit3.Value)].nWType;
      TrackBar1.Max := w+150;
      Trackbar1.Position := Weapons[trunc(SpinEdit3.Value)].x;
      TrackBar2.Max := h+150;
      Trackbar2.Position := Weapons[trunc(SpinEdit3.Value)].y;
      end;
    end;
  end;
  
function TForm1.get_separator(c: char; s: string): integer;
var
  i: integer;
begin
  get_separator := -1;
  for i:=0 to Length(s)+1 do begin
    if s[i]=c then begin
      get_separator := i;
      break;
      end;
    end;
  end;
  
function TForm1.getnextint(var s: string; c: char): integer;
var
  s1,s2: string;
  sep: integer;
begin
  s1 := s;
  sep := get_separator(c,s1)+1;
  if sep <> 0 then begin
    s2 := Copy(s1,0,sep-2);
    getnextint := StrToInt(s2);
    s := Copy(s1,sep,Length(s1)-sep+1);
    end
  else begin
    getnextint := StrToInt(s1);
    end;
  end;
  
procedure TForm1.ClearLevel;
var
  i: integer;
begin
  nMarked := -1;
  SpinEdit1.MaxValue := MAX_WEAPONS;

  for i:=0 to MAX_OBJECTS do with Objects[i] do begin
    x := 0;
    y := 0;
    w := 64;
    h := 64;
    nImage := 0;
    nType := 0;
    end;

  scroll_x := 0;
  scroll_y := 0;
  nTargetType := 2;
  nLevelLength := 500;
  
  update_controls(-1);
  
  Form1.Caption := 'Far Away Level Editor '+VERSION+' [new level]';
  end;

initialization
  {$I hprg.lrs}
  
end.

